import java.io.*;
import java.util.*;
import java.math.*;

public class next_ab_bug implements Runnable {

	private void solve() throws IOException {
		String s = in.next();
		String[] s1 = s.split("=");
		myAssert(s1.length == 2);
		int n = Integer.parseInt(s1[0]);
		myAssert(1 <= n && n <= 100000);
		String[] s2 = s1[1].split("\\+");
		int[] a = new int[s2.length];
		int tn = 0;
		for (int i = 0; i < a.length; ++i) {
			a[i] = Integer.valueOf(s2[i]);
			myAssert(1 <= a[i] && a[i] <= n);
			tn += a[i];
		}
		myAssert(tn == n);
		
		if (a.length == 1) {
			out.println("No solution");
		} else {
			if (a[a.length - 1] - a[a.length - 2] >= 2) {
				a[a.length - 2]++;
				a[a.length - 1]--;
			} else {
				a[a.length - 2] += a[a.length - 1];
				a = Arrays.copyOf(a, a.length - 1);
			}
			out.print(n + "=");
			for (int i = 0; i < a.length; ++i) {
				if (i > 0) out.print("+");
				out.print(a[i]);
			}
			out.println();
		}
		
	}

	void myAssert(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	final String FILE_NAME = "next";

	SimpleScanner in;
	PrintWriter out;

	@Override
	public void run() {
		try {
			in = new SimpleScanner(new FileReader(FILE_NAME + ".in"));
			out = new PrintWriter(FILE_NAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	public static void main(String[] args) {
		new Thread(new next_ab_bug()).start();
	}

	class SimpleScanner extends BufferedReader {

		private StringTokenizer st;
		private boolean eof;

		public SimpleScanner(Reader a) {
			super(a);
		}

		String next() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(readLine());
				} catch (Exception e) {
					eof = true;
					return "";
				}
			}
			return st.nextToken();
		}

		boolean seekEof() {
			String s = next();
			if ("".equals(s) && eof)
				return true;
			st = new StringTokenizer(s + " " + st.toString());
			return false;
		}

		private String cnv(String s) {
			if (s.length() == 0)
				return "0";
			return s;
		}

		int nextInt() {
			return Integer.parseInt(cnv(next()));
		}

		double nextDouble() {
			return Double.parseDouble(cnv(next()));
		}

		long nextLong() {
			return Long.parseLong(cnv(next()));
		}
	}
}